SystemOrganization addCategory: #JuegoBreak!

SimpleSwitchMorph subclass: #LOCelda
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JuegoBreak'!

!LOCelda methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:10'!
initialize 
	super initialize.
	self label:''.
	self borderWidth: 2.
	bounds  := 0@0 corner: 16@16.
	offColor  := Color paleYellow.
	onColor := Color paleMagenta darker .
	self useSquareCorners.
	self turnOff! !

!LOCelda methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:11'!
mouseAction: aBlock 
	^mouseAction := aBlock ! !

!LOCelda methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:11'!
mouseUp: anEvent
	mouseAction value ! !

StandardWindow subclass: #VentanaPrincipal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JuegoBreak'!

!VentanaPrincipal methodsFor: 'as yet unclassified' stamp: 'Ronald 9/25/2012 13:28'!
initialize
| contenedorJuego |
super initialize .

self setLabel: 'Juego - TO'.
self setWindowColor: Color black .
self borderWidth: 2.
self borderColor: (Color r: 0 g:0 b: 0).
self useSquareCorners.	
self position: 0@0.

contenedorJuego := LOJuego new.
contenedorJuego position: 50@50.
self  addMorph: contenedorJuego! !

BorderedMorph subclass: #LOJuego
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'JuegoBreak'!

!LOJuego methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:20'!
cellsPerSide
	"The number of cells along each side of the game"
	^20! !

!LOJuego methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:30'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCelda  new.
	width := sampleCell width.
	height :=sampleCell height.
	self bounds: (5@5 extent: ((width *n)@(height*n))+(2* self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j].! !

!LOJuego methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:09'!
mouseMove: anEvent! !

!LOJuego methodsFor: 'initialization' stamp: 'Ronald 9/25/2012 13:30'!
newCellAt:i at:j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCelda new.
	origin := self innerBounds  origin.
	self addMorph: c.
	c position: ((i-1)* c width) @ ((j-1)* c height  ) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt:i at:j].
	^c! !

!LOJuego methodsFor: 'as yet unclassified' stamp: 'Ronald 9/27/2012 15:37'!
toggleNeighboursOfCellAt: i at: j
|num|
num := (1 to: 2) atRandom .
(num =  1) ifTrue: 
			[
				(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
				(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
				(j > 1) ifTrue: [ (cells at: i at: j - 1) toggleState].
				(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
			]
		    ifFalse:
			[
				(i > 1 & j> 1) ifTrue: [ (cells at: i - 1 at: j - 1 ) toggleState].
				(i < self cellsPerSide & j < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j + 1) toggleState].
				(j > 1 & i < self cellsPerSide) ifTrue: [ (cells at: i + 1at: j - 1) toggleState].
				(j < self cellsPerSide & i>1) ifTrue: [ (cells at: i - 1 at: j + 1) toggleState].
			]! !
